#include "MainWindow.h"
#include "ui_MainWindow.h"

#include <QDebug>

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    auto webView = ui->webView;
    QObject::connect(webView, &QWebEngineView::loadStarted, this, &MainWindow::loadStarted);
    QObject::connect(webView, &QWebEngineView::loadProgress, this, &MainWindow::loadProgress);
    QObject::connect(webView, &QWebEngineView::loadFinished, this, &MainWindow::loadFinished);
    QObject::connect(webView, &QWebEngineView::titleChanged, this, &MainWindow::titleChanged);
    QObject::connect(webView, &QWebEngineView::selectionChanged, this, &MainWindow::selectionChanged);
    QObject::connect(webView, &QWebEngineView::urlChanged, this, &MainWindow::urlChanged);
    QObject::connect(webView, &QWebEngineView::iconUrlChanged, this, &MainWindow::iconUrlChanged);
    QObject::connect(webView, &QWebEngineView::iconChanged, this, &MainWindow::iconChanged);
    QObject::connect(webView, &QWebEngineView::renderProcessTerminated, this, &MainWindow::renderProcessTerminated);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::loadStarted()
{
    qDebug() << "load started";
}

void MainWindow::loadProgress(int progress)
{
    qDebug() << "load progress" << progress;
}

void MainWindow::loadFinished(bool ok)
{
    qDebug() << "load progress" << ok;
}

void MainWindow::titleChanged(const QString &title)
{
    qDebug() << "title changed" << title;
}

void MainWindow::selectionChanged()
{
    qDebug() << "selection changed";
}

void MainWindow::urlChanged(const QUrl &url)
{
    qDebug() << "url changed" << url;
}

void MainWindow::iconUrlChanged(const QUrl &url)
{
    qDebug() << "icon url changed" << url;
}

void MainWindow::iconChanged(const QIcon &icon)
{
    qDebug() << "icon  changed" << icon;
}

void MainWindow::renderProcessTerminated(QWebEnginePage::RenderProcessTerminationStatus terminationStatus, int exitCode)
{
    qDebug() << "render process terminated" << terminationStatus << exitCode;
}

void MainWindow::on_loadButton_clicked()
{
    ui->webView->load(ui->urlEdit->text());
}
