#pragma once

#include <QMainWindow>
#include <QWebEnginePage>

namespace Ui { class MainWindow; }

class MainWindow : public QMainWindow
{
    Q_OBJECT
    
public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

    void loadStarted();
    void loadProgress(int progress);
    void loadFinished(bool ok);
    void titleChanged(const QString& title);
    void selectionChanged();
    void urlChanged(const QUrl&url);
    void iconUrlChanged(const QUrl&);
    void iconChanged(const QIcon&);
    void renderProcessTerminated(QWebEnginePage::RenderProcessTerminationStatus terminationStatus, int exitCode);
    
private slots:
    void on_loadButton_clicked();
    
private:
    Ui::MainWindow *ui;
};
